// set our "on load" handler.
window.addEventListener("load", mg_load, false);

	
function findApp()
{
	var wrk = Components.classes["@mozilla.org/windows-registry-key;1"].createInstance(Components.interfaces.nsIWindowsRegKey);
	wrk.open(wrk.ROOT_KEY_LOCAL_MACHINE,
    		 "Software\\MediaGet",
            	 wrk.ACCESS_READ);
	var sPath = wrk.readStringValue("");
	wrk.close();
	return sPath;
}


function getCookies()
{
	var doc;  
	doc = dialog.mContext.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIDOMWindow).document;

   	var _host = doc.location.hostname;

	var cookieManager =
      		Components.classes["@mozilla.org/cookiemanager;1"].getService(Components.interfaces.nsICookieManager);
   	var _cookie = "";

   	for (var iter = cookieManager.enumerator; iter.hasMoreElements();) 
   	{
      		if ((objCookie = iter.getNext()) instanceof Components.interfaces.nsICookie) 
      		{
        		var cookieHost = objCookie.host;
        		if (cookieHost.charAt(0) == ".")
          			cookieHost = cookieHost.substring (1);

       		 	if (cookieHost == _host || _host.indexOf ("." + cookieHost) != -1)
       	 		{
		        	if (_cookie.indexOf (objCookie.name + "=" + objCookie.value) == -1)
	        		{
		        		if (_cookie.length)
		        			_cookie += "; ";
	        			_cookie += objCookie.name + "=" + objCookie.value;
	        		}
			}

	  
      		}
   	}

	return _cookie;
}

function testUrl(url){
	return (url.left(4) == "http");
}


function mg_load(ev)
{	

	var _url = dialog.mLauncher.source.spec;

	var _cookie = "";
	    _cookie = getCookies();	
	
	try{		
		var iid = ("nsIProcess2" in Components.interfaces) ? Components.interfaces.nsIProcess2 : Components.interfaces.nsIProcess;
		var process = Components.classes["@mozilla.org/process/util;1"].createInstance(iid);
	
		var file = Components.classes["@mozilla.org/file/local;1"].createInstance (Components.interfaces.nsILocalFile);
		file.initWithPath(findApp());

		process.init(file);
		var args = ["--webdownload__"+_url+"__"+btoa(_cookie)];
		process.run(false, args, args.length);

		document.documentElement.cancelDialog();

	}catch(e){
		alert(e.message);
	}	

			
}
